%filter_from_requires /^perl.MooseX.ErsatzMethod.Trait.Role.pm./d
%define module_name MooseX-ErsatzMethod
# BEGIN SourceDeps(oneline):
BuildRequires: perl(ExtUtils/MakeMaker.pm) perl(Module/Runtime.pm) perl(Moose.pm) perl(Test/More.pm) perl(thanks.pm)
# END SourceDeps(oneline)
%define _unpackaged_files_terminate_build 1
BuildRequires: rpm-build-perl perl-devel perl-podlators

Name: perl-%module_name
Version: 0.005
Release: alt1
Summary: provide a method implementation that isn't as good as the real thing
Group: Development/Perl
License: perl
URL: https://metacpan.org/release/MooseX-ErsatzMethod

Source0: http://mirror.yandex.ru/mirrors/cpan/authors/id/T/TO/TOBYINK/%{module_name}-%{version}.tar.gz
BuildArch: noarch

%description
MooseX::ErsatzMethod provides a mechanism for Moose roles to provide fallback
implementations of methods that they really want for consuming classes to
implement. In the SYNOPSIS section, the `Greetable' role really wants
consuming classes to implement a `name' method. The `Termite' class doesn't
implement `name', but it's OK, because `Greetable' provides a fallback
(albeit rubbish) implementation of the method.

But wait! I hear you say. Don't roles already work that way? Can't a
role provide an implementation of a method which consuming classes can
override? Yes, they can. However, the precedence is:

  consuming class's implementation (wins)
  role's implementation
  inherited implementation (e.g. from parent class)

That is, the role's method implementation overrides methods inherited from the
parent class. An ersatz method implementation sits right at the bottom of the
heirarchy; it is only used if the consuming class and its ancestors cannot
provide the method. (It still beats `AUTOLOAD' though.)

One other feature of ersatz methods is that they can never introduce role
composition conflicts. If you compose two different roles which both provide
ersatz method implementations, an arbitrary method implementation is selected.


%prep
%setup -q -n %{module_name}-%{version}

%build
%perl_vendor_build

%install
%perl_vendor_install

%files
%doc README CREDITS LICENSE Changes COPYRIGHT
%perl_vendor_privlib/M*

%changelog
* Thu Oct 26 2017 Igor Vlasenko <viy@altlinux.ru> 0.005-alt1
- regenerated from template by package builder

* Sat Apr 09 2016 Igor Vlasenko <viy@altlinux.ru> 0.004-alt1.1
- rebuild to restore role requires

* Mon Sep 22 2014 Igor Vlasenko <viy@altlinux.ru> 0.004-alt1
- regenerated from template by package builder

* Tue Oct 15 2013 Igor Vlasenko <viy@altlinux.ru> 0.003-alt2
fixed requires

* Mon Oct 14 2013 Igor Vlasenko <viy@altlinux.ru> 0.003-alt1
- initial import by package builder

